@echo off

echo:
echo nginx for Windows http://nginx-win.ecsds.eu/
echo:
echo This script will create an User and a Service for PHP.
echo Once the User has been created make sure you allow and/or deny access to
echo   other folders and/or files the PHP Service requires or are NOT
echo   required on a User level.
echo For example the log folders must be writable for the User.
echo A default created user is a member of 'users' which have limited access,
echo   this script makes no attempt to limit this any further, you are
echo   encouraged to do this yourself.
echo:
echo This script also assumes PHP is already installed (extracted from
echo   the .zip archive) in c:\php
echo:
pause

cd /d "%~dp0"

set PH_Password=%RANDOM%%PROCESSOR_REVISION%
set PH_Username=php-win
set PH_Path=c:\php
set PH_PathR=c:\\php
set PH_Exec=php-cgi.exe
set PH_CfgPath=php.ini
set PH_Servname=phpcgiwin
set PH_Desc=PHPcgi for Windows
set PH_Password=%PH_Password%%RANDOM%

echo Checking values...
rem checking values
if exist %PH_Path%\%PH_Exec% goto c1
echo The file and/or path %PH_Path%\%PH_Exec% does not exist. Exit.
goto end
:c1
if exist %PH_Path%\%PH_CfgPath% goto c2
echo There is no configuration file %PH_Path%\%PH_CfgPath% . Exit.
goto end
:c2

echo Creating PHP user...
rem Create a user
net user %PH_Username% %PH_Password% /add
net user %PH_Username% /expires:never
WMIC USERACCOUNT WHERE "Name='%PH_Username%'" SET PasswordExpires=FALSE
rem cacls %PH_Path%\logs /t /e /c /g %PH_Username%:F
copy /b/y srvany.exe %PH_Path%
copy /b/y initialize_runcgi.cmd %PH_Path%
copy /b/y multi_runcgi.cmd %PH_Path%
copy /b/y sleep.exe %PH_Path%

rem Add user to a specific group, currently disabled
rem net localgroup group_name %PH_Username% /add

echo Creating PHP service...
rem Create the service
sc create %PH_Servname% binPath= %PH_Path%\srvany.exe start= auto obj= %COMPUTERNAME%\%PH_Username% password= %PH_Password% DisplayName= "%PH_Desc%"
ntrights +r SeServiceLogonRight -u "%COMPUTERNAME%\%PH_Username%"

echo Creating scripts for start and stop...
rem Create a stop script
echo @echo off>%PH_Path%\php_stop.cmd
echo cd /d %PH_Path%>>%PH_Path%\php_stop.cmd
echo net stop %PH_Servname%>>%PH_Path%\php_stop.cmd
echo TASKKILL /F /FI "USERNAME eq %PH_Username%" /IM "*">>%PH_Path%\php_stop.cmd

rem Create a start script
echo @echo off>%PH_Path%\php_start.cmd
echo cd /d %PH_Path%>>%PH_Path%\php_start.cmd
echo net start %PH_Servname%>>%PH_Path%\php_start.cmd

echo Creating service registry changes and applying them...
rem Create registry changes
echo REGEDIT4>%PH_Path%\php_regvals.reg
echo:>>%PH_Path%\php_regvals.reg
echo [HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\%PH_Servname%\Parameters]>>%PH_Path%\php_regvals.reg
echo "Application"="%PH_PathR%\\initialize_runcgi.cmd">>%PH_Path%\php_regvals.reg
echo "AppParameters"="">>%PH_Path%\php_regvals.reg
echo "AppDirectory"="%PH_PathR%">>%PH_Path%\php_regvals.reg
regedit /s %PH_Path%\php_regvals.reg

echo:
echo All done !
:end
pause
